.\" Copyright (c) 1980, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)last.1	8.1 (Berkeley) 6/6/93
.\"
.Dd June 6, 1993
.Dt LAST 1
.Os BSD 4
.Sh NAME
.Nm last
.Nd indicate last logins of users and ttys
.Sh SYNOPSIS
.Nm last
.Op Fl Ns Ar n
.Op Fl f Ar file
.Op Fl h Ar host
.Op Fl s
.Op Fl t Ar tty
.Op Fl w
.Op user ...
.Sh DESCRIPTION
.Nm Last
will list the sessions of specified
.Ar users ,
.Ar ttys ,
and
.Ar hosts ,
in reverse time order.  Each line of output contains
the user name, the tty from which the session was conducted, any
hostname, the start and stop times for the session, and the duration
of the session.  If the session is still continuing or was cut short by
a crash or shutdown,
.Nm last
will so indicate.
.Pp
.Bl -tag -width indent-two
.It Fl Ar n
Limits the report to
.Ar n
lines.
.It Fl f Ar file
.Nm Last
reads the file
.Ar file
instead of the default,
.Pa /var/log/wtmp .
.It Fl h Ar host
.Ar Host
names may be names or internet numbers.
.It Fl s
Report the duration of the login session in seconds, instead of the
default days, hours and minutes.
.It Fl t Ar tty
Specify the
.Ar tty .
Tty names may be given fully or abbreviated, for example,
.Dq Li "last -t 03"
is
equivalent to
.Dq Li "last -t tty03" .
.It Fl w
Widen the duration field to show seconds, as well as the
default days, hours and minutes.
.El
.Pp
If
multiple arguments are given, the information which applies to any of the
arguments is printed, e.g.,
.Dq Li "last root -t console"
would list all of
.Dq Li root Ns 's
sessions as well as all sessions on the console terminal. If no
users, hostnames or terminals are specified,
.Nm last
prints a record of
all logins and logouts.
.Pp
The pseudo-user
.Ar reboot
logs in at reboots of the system, thus
.Dq Li last reboot
will give an indication of mean time between reboot.
.Pp
If
.Nm last
is interrupted, it indicates to what date the search has
progressed.  If interrupted with a quit signal
.Nm last
indicates how
far the search has progressed and then continues.
.Sh FILES
.Bl -tag -width /var/log/wtmp -compact
.It Pa /var/log/wtmp
login data base
.El
.Sh SEE ALSO
.Xr lastcomm 1 ,
.Xr utmp 5 ,
.Xr ac 8
.Sh BUGS
If a login shell should terminate abnormally for some reason, it is likely
that a logout record won't be written to the wtmp file. In this case,
.Nm last
will indicate the logout time as "shutdown".
.Sh HISTORY
.Nm Last
appeared in
.Bx 3.0 .
